//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#define KeyToUse "LhDTiyrCQ6fues5pXEuo2i4Mg3IgvXe4STWQEROgqHFX8eQwfySDUhg8QwqGmuIvt2F36jhT4FouWNEqtDoucTlgjuOnSVstBqs7QPCu4x84ndnNitydDgwUPmlgFtle"

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

int DaysLeftInTrial(void)
{
    SYSTEMTIME ST;

    GetLocalTime(&ST);

    DWORD ToDay = DateToLong(ST.wYear, ST.wMonth,  ST.wDay);

    DWORD DaysLeft = (ExpireDate - ToDay);

    if(DaysLeft > TrialDays || DaysLeft < 0)
    {
        KillTimer(TrayIcon_hWnd, 1);
        sprintf(RegistrationText, "An error has occured in the trial registration process.");
        DialogBox(MainInstance, MAKEINTRESOURCE(TimeToRegister), TrayIcon_hWnd, TimeToRegisterDialog);
        IsExpired    = TRUE;
        IsRegistered = FALSE;
        return 0;
    }

    return (int) DaysLeft;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

bool CheckExpiration(void)
{
    if(IsRegistered || IsExpired)
        return true;

    if(ExpireDate == 0)
    {
        SYSTEMTIME ST;

        GetLocalTime(&ST);

        DWORD ToDay = DateToLong(ST.wYear, ST.wMonth,  ST.wDay);

        ExpireDate = (ToDay + TrialDays);
    }
    else{
        SYSTEMTIME ST;

        GetLocalTime(&ST);

        DWORD ToDay = DateToLong(ST.wYear, ST.wMonth,  ST.wDay);

        if(ToDay > ExpireDate)
        {
            // Expired code
            IsExpired = TRUE;
            KillTimer(TrayIcon_hWnd, 1);
            sprintf(RegistrationText, "The SQLBackup trial has expired.");
            DialogBox(MainInstance, MAKEINTRESOURCE(TimeToRegister), TrayIcon_hWnd, TimeToRegisterDialog);
        }
        else{
            // Not expired code;

            int DaysLeft = DaysLeftInTrial();

            if(DaysLeft > TrialDays || DaysLeft < 0)
            {
                KillTimer(TrayIcon_hWnd, 1);
                sprintf(RegistrationText, "An error has occured in the trial registration process.");
                DialogBox(MainInstance, MAKEINTRESOURCE(TimeToRegister), TrayIcon_hWnd, TimeToRegisterDialog);
                IsExpired    = TRUE;
                IsRegistered = FALSE;
                return false;
            }
        }
    }

    return true;
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

bool Compare(char *String1, char *String2, int Size)
{
	int LocalLoop = 0;

	while(LocalLoop < Size)
	{
		if(String1[LocalLoop] != String2[LocalLoop])
			return false;

        LocalLoop++;
	}

	return true;
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

bool VerifiyKey(char *RegisterFile, char *Key1, char *Key2, char *Key3)
{
    bool ReturnValue = false;
    int LocalLoop = 0;

    _NASCCL Crypt;
    _NDBSTable NDBS;

    int Attribs  = (ROUNDMUTATION | SWAPMATRIX | ROUNDRESULT | NONREPETITION | ENSUREOFFSET | FMATRIXMUTATION | RMATRIXMUTATION | CMATRIXMUTATION | CRYPTFULLDATASET | RUNNINGKEYPOSITION);

	if(ReadNDBSFile(&NDBS, RegisterFile) == false)
        return false;

    char KeyHash[1024 + 1];
    HashKey(KeyToUse, KeyHash, strlen(KeyToUse), 1024);
    InitializeCryptographySet(&Crypt, KeyHash, 1024, Attribs);

    Crypt.Data = (char *) calloc(8 + 1, 1);

    Crypt.SizeOfData = 8;

    //------------------------------------------------------------------------------------

    char KeyValue1[8 + 1];
    char KeyValue2[8 + 1];
    char KeyValue3[8 + 1];

    while(LocalLoop < 10000)
    {
        RetreiveDataByColumbPosition(&NDBS, 0, LocalLoop, Crypt.Data);
        Decode(&Crypt, KeyValue1);

        RetreiveDataByColumbPosition(&NDBS, 1, LocalLoop, Crypt.Data);
        Decode(&Crypt, KeyValue2);

        RetreiveDataByColumbPosition(&NDBS, 2, LocalLoop, Crypt.Data);
        Decode(&Crypt, KeyValue3);

        KeyValue1[8] = '\0';
        KeyValue2[8] = '\0';
        KeyValue3[8] = '\0';
/*
        char Temp1[10240];
        char Temp2[10240];
        sprintf(Temp1, "%s-%s-%s", KeyValue1, KeyValue2, KeyValue3);
        sprintf(Temp2, "%s-%s-%s", Key1, Key2, Key3);
        MessageBox(RegistrationDialog_hWnd, Temp1, Temp2, 0);
*/
        if( Compare(KeyValue1, Key1, 8) )
        {
            if( Compare(KeyValue2, Key2, 8) )
            {
                if( Compare(KeyValue3, Key3, 8) )
                {
                    FreeTable(&NDBS);
                    ReturnValue =  true;
                    break;
                }
            }
        }

        LocalLoop++;
    }

    UninitializeCryptographySet(&Crypt);

    FreeTable(&NDBS);

	return ReturnValue;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

BOOL InitilizeRegistration(void)
{
    unsigned long SizeOfBuffer = 8;

    if(CheckRegistration == FALSE)
    {
        return TRUE;
    }

    if(VerifiyKey(CodedKeysDB, RegKey1, RegKey2, RegKey3))
    {
        IsRegistered = TRUE;
        return TRUE;
    }
    else{
        ErrorMessage(NULL, "Registration failed.");
        IsRegistered = FALSE;
        return FALSE;
    }

	return FALSE;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

